/// <reference types="react" />
import { ReactElement } from "react";
import ArenaActionTypes from "redux-arena/ActionTypes";
import ActionTypes from "./ActionTypes";
import AnimationPhases from "./AnimationPhases";
import { State, PlayEntity } from "./types";
import PlayStrategies from "./PlayStrategies";
export declare function setState(state: State): {
    type: ArenaActionTypes;
    state: State;
};
export declare function nextPhase(phase: AnimationPhases, oldPlayKey: string, oldPlay: PlayEntity): {
    type: ActionTypes;
    phase: AnimationPhases;
    oldPlayKey: string;
    oldPlay: PlayEntity;
};
export declare function addPlay(element: ReactElement<{}>): {
    type: ActionTypes;
    entity: {
        element: ReactElement<{}>;
    };
};
export declare function removePlay(element: ReactElement<{}>): {
    type: ActionTypes;
    element: ReactElement<{}>;
};
export declare function playNext(PlayStrategies?: PlayStrategies): {
    type: ActionTypes;
    PlayStrategies: PlayStrategies | undefined;
};
declare const _default: {
    setState: (state: State) => {
        type: ArenaActionTypes;
        state: State;
    };
    nextPhase: (phase: AnimationPhases, oldPlayKey: string, oldPlay: PlayEntity) => {
        type: ActionTypes;
        phase: AnimationPhases;
        oldPlayKey: string;
        oldPlay: PlayEntity;
    };
    addPlay: (element: ReactElement<{}>) => {
        type: ActionTypes;
        entity: {
            element: ReactElement<{}>;
        };
    };
    removePlay: (element: ReactElement<{}>) => {
        type: ActionTypes;
        element: ReactElement<{}>;
    };
    playNext: (PlayStrategies?: PlayStrategies | undefined) => {
        type: ActionTypes;
        PlayStrategies: PlayStrategies | undefined;
    };
};
export default _default;
