import initState from "./state";
import ActionTypes from "./ActionTypes";
import AnimationPhases from "./AnimationPhases";
import PlayStrategies from "./PlayStrategies";
function nextPhaseState(state, action) {
    var _a = action, phase = _a.phase, oldPlayKey = _a.oldPlayKey, oldPlay = _a.oldPlay;
    if (state.phase !== phase || state[oldPlayKey] !== oldPlay)
        return state;
    switch (state.phase) {
        case AnimationPhases.ENTERING:
            var newPlayKey = void 0;
            if (state.newPlayKey === "play2") {
                newPlayKey = "play1";
            }
            else {
                newPlayKey = "play2";
            }
            return Object.assign({}, state, (_b = {
                    phase: AnimationPhases.IN
                },
                _b[newPlayKey] = {},
                _b.newPlayKey = newPlayKey,
                _b));
        case AnimationPhases.LEAVING:
            return Object.assign({}, state, { phase: AnimationPhases.OUT });
        case AnimationPhases.OUT:
            return Object.assign({}, state, { phase: AnimationPhases.ENTERING });
        default:
            return state;
    }
    var _b;
}
function playRemoveState(state, action) {
    var oldPlayKey = state.newPlayKey === "play1" ? "play2" : "play1";
    if (state.phase == AnimationPhases.IN &&
        state[oldPlayKey] === action.element) {
        return Object.assign({}, state, { phase: AnimationPhases.LEAVING });
    }
    else if (state[state.newPlayKey].element === action.element) {
        return Object.assign({}, state, { autoClearPlay: action.element });
    }
    else {
        return Object.assign({}, state, {
            playlist: state.playlist.filter(function (entity) { return entity.element !== action.element; })
        });
    }
}
export default function (state, action) {
    if (state === void 0) { state = initState; }
    switch (action.type) {
        case ActionTypes.ARENA_SWITCH_ANIMATION_NEXTPHRASE:
            return nextPhaseState(state, action);
        case ActionTypes.ARENA_SWITCH_ANIMATION_PLAY_NEXT:
            if (state.playlist.length === 0 && state.autoClearPlay == null)
                return state;
            var newState = Object.assign({}, state);
            if (state.phase === AnimationPhases.IN) {
                newState.phase = AnimationPhases.LEAVING;
            }
            else if (state.phase === AnimationPhases.OUT &&
                state.autoClearPlay != null) {
                newState.autoClearPlay = null;
            }
            else {
                return state;
            }
            if (state.playlist.length > 0) {
                if (state.play1.element == null && state.play2.element == null) {
                    newState.phase = AnimationPhases.OUT;
                }
                switch (action.PlayStrategies) {
                    case PlayStrategies.PLAT_NEXT:
                        newState[state.newPlayKey] = state.playlist[0];
                        newState.playlist = state.playlist.slice(1);
                    default:
                        newState[state.newPlayKey] =
                            state.playlist[state.playlist.length - 1];
                        newState.playlist = [];
                }
            }
            return newState;
        case ActionTypes.ARENA_SWITCH_ANIMATION_PLAY_ADD:
            return Object.assign({}, state, {
                playlist: state.playlist.concat(action.entity)
            });
        case ActionTypes.ARENA_SWITCH_ANIMATION_PLAY_REMOVE:
            return playRemoveState(state, action);
        default:
            return state;
    }
}
