Object.defineProperty(exports, "__esModule", { value: true });
var ActionTypes_1 = require("redux-arena/ActionTypes");
var ActionTypes_2 = require("./ActionTypes");
function setState(state) {
    return {
        type: ActionTypes_1.default.ARENA_SCENE_SET_STATE,
        state: state
    };
}
exports.setState = setState;
function nextPhase(phase, oldPlayKey, oldPlay) {
    return {
        type: ActionTypes_2.default.ARENA_SWITCH_ANIMATION_NEXTPHRASE,
        phase: phase,
        oldPlayKey: oldPlayKey,
        oldPlay: oldPlay
    };
}
exports.nextPhase = nextPhase;
function addPlay(element) {
    return {
        type: ActionTypes_2.default.ARENA_SWITCH_ANIMATION_PLAY_ADD,
        entity: {
            element: element
        }
    };
}
exports.addPlay = addPlay;
function removePlay(element) {
    return {
        type: ActionTypes_2.default.ARENA_SWITCH_ANIMATION_PLAY_REMOVE,
        element: element
    };
}
exports.removePlay = removePlay;
function playNext(PlayStrategies) {
    return {
        type: ActionTypes_2.default.ARENA_SWITCH_ANIMATION_PLAY_NEXT,
        PlayStrategies: PlayStrategies
    };
}
exports.playNext = playNext;
exports.default = { setState: setState, nextPhase: nextPhase, addPlay: addPlay, removePlay: removePlay, playNext: playNext };
