Object.defineProperty(exports, "__esModule", { value: true });
function isCurPhaseEnd(prevStyles, nextPhaseCheckers) {
    return prevStyles.find(function (styleObj) {
        var key = styleObj.key, style = styleObj.style;
        switch (key) {
            case "container":
                return nextPhaseCheckers.container
                    ? nextPhaseCheckers.container(style) === true ? true : false
                    : false;
            case "oldPlay":
                return nextPhaseCheckers.oldPlay
                    ? nextPhaseCheckers.oldPlay(style) === true ? true : false
                    : false;
            case "newPlay":
                return nextPhaseCheckers.newPlay
                    ? nextPhaseCheckers.newPlay(style) === true ? true : false
                    : false;
            default:
                return false;
        }
    }) == null
        ? false
        : true;
}
exports.isCurPhaseEnd = isCurPhaseEnd;
function calcStyle(style, phase, calculator) {
    return Object.assign({}, calculator ? calculator(style, phase) : style, {
        phase: phase
    });
}
function buildStyleCalculator(styleCalculators, phase, nextPhaseCheckers, nextPhase) {
    return function (prevStyles) {
        return prevStyles.map(function (styleObj) {
            var key = styleObj.key, style = styleObj.style;
            switch (key) {
                case "container":
                    return {
                        key: "container",
                        style: calcStyle(style, phase, styleCalculators.container)
                    };
                case "oldPlay":
                    return {
                        key: "oldPlay",
                        style: calcStyle(style, phase, styleCalculators.oldPlay)
                    };
                case "newPlay":
                    return {
                        key: "newPlay",
                        style: calcStyle(style, phase, styleCalculators.newPlay)
                    };
                case "nextPhase":
                    if (isCurPhaseEnd(prevStyles, nextPhaseCheckers)) {
                        nextPhase(style.phase);
                    }
                    return {
                        key: "nextPhase",
                        style: {
                            phase: phase
                        }
                    };
                default:
                    return styleObj;
            }
        });
    };
}
exports.buildStyleCalculator = buildStyleCalculator;
function calcKeys(newPlayKey) {
    if (newPlayKey === "play2")
        return {
            newPlayKey: newPlayKey,
            oldPlayKey: "play1"
        };
    else
        return {
            newPlayKey: newPlayKey,
            oldPlayKey: "play2"
        };
}
exports.calcKeys = calcKeys;
